---
title: 'ARIA: alert role'
slug: Web/Accessibility/ARIA/Roles/Alert_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA alert
  - ARIA widget
  - Reference
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p class="summary"><span class="seoSummary">The <a href="https://www.w3.org/TR/wai-aria-1.1/#alert">alert</a> role can be used to tell the user an element has been dynamically updated. Screen readers will instantly start reading out the updated content when the role is added. If the user is expected to close the alert, then the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Alertdialog_Role">alertdialog</a> role should be used instead.</span></p>

<h2 id="Description">Description</h2>

<p>One of the five live region roles, the <a href="https://www.w3.org/TR/wai-aria-1.1/#alert">alert</a> role is used to provide the user with important, and usually time-sensitive, information, and often to tell the user an element has been dynamically updated.</p>

<p>The <code>alert</code> role is added to the node containing an alert message, not the element causing the alert to be triggered. Alerts are assertive live regions. Setting <code>role="alert"</code> is equivalent to setting aria-live="assertive" and aria-atomic="true". They don't receive focus, and therefore focus does not need to be managed and no user interaction should be required.</p>

<p>The most important thing to know about the alert role is that it is for dynamic content. It is perfect for situations such as when a user fills out a form and JavaScript is used to add an error message - the alert would immediately read out the message. It should not be used on HTML where the user hasn't interacted with it. For example, if a page loads with multiple visible alerts scattered throughout, none would be read because they are not dynamically triggered. </p>

<h2 id="Examples">Examples</h2>

<p>The most basic way to trigger an alert is by adding <code>role="alert"</code> to an element that has <code>display: none;</code> by default. When the <a href="/en-US/docs/Web/CSS/CSS_Display">display</a> value is changed with CSS or JavaScript, it would automatically trigger the screen reader to read out the content.</p>

<pre class="brush: html">&lt;p role="alert" style="display: none;"&gt;The alert will trigger when the element becomes visible.&lt;/p&gt;</pre>

<p>While triggering an alert via CSS alone is possible, it is better to rely on JavaScript because it has more browser/screen reader support and is often more appropriate as part of a larger user interaction such as inside an event handler or form validation. With JavaScript, developers control the adding and removing of alerts as appropriate.</p>

<pre class="brush: html">&lt;button type="button" onclick="triggerAlert"&gt;Trigger alert&lt;/button&gt;
&lt;p class="alert"&gt;The alert will trigger when the button is pressed.&lt;/p&gt;
</pre>

<pre class="brush: js">function triggerAlert() {
  var alertEl = document.querySelector('.alert');
  alertEl.addAttribute("role", "alert");
}
</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>The alert role should read out content that has changed, or bring the user's attention to it immediately, so it should not be used for static content or used regularly. Alerts, by definition, are disruptive. Lots of alerts at once or unnecessary alerts willl create a bad user experience.  </p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#alert","Alert")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#alert","Alert")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Alertdialog_Role">ARIA: Alertdialog Role</a></li>
 <li><a href="https://developer.paciellogroup.com/blog/2017/04/aria-alert-support/">ARIA alert support - The Paciello Group</a></li>
 <li>ARIA Live Regions</li>
</ul>
